/*
NAME:     ppw
SYNOPSIS: ppw [puerto_local][ip_proxy][puerto_proxy]
*/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>


#define MAXHOSTNAME 80
void reusePort(int sock);//FUNCION PARA REUSAR EL PUERTO.
int bytes_desde_el_inicio=0;//BYTES QUE TRANSFIERE EL PROXY AL PPW(PESO DE LA PGINA).
int bytes_desde_el_ultimo_enter=0;//BYTES QUE TRANSFIERE EL PROXY AL PPW DESDE EL LTIMO ENTER(PESO DE LA PGINA).

main( argc, argv )
int argc;
char *argv[];
{
  	int s, ss, sl;
	struct sockaddr_in server;//EN ESTA ESTRUCTURA SE GUARDARAN ALGUNOS DATOS DEL SERVIDOR(EN NUESTRO CASO ARAGORN).
	struct sockaddr_in from;//EN ESTA ESTRUCTURA SE GUARDARAN LOS DATOS DE LOS CLIENTES.
  	struct sockaddr_in proxy;//EN ESTA ESTRUCTURA SE GUARDAN LOS DATOS DEL PROXY
	int largofrom;//GUARDO EL TAMAO DE LA ESTRUCTURA FROM.


  	fd_set readfds, readfdsCopy;//CONJUNTOS DE DEESCRIPTORES QUE UTILIZARA LA FUNCIN SELECT.
  	int n,i,numero_de_conexiones=0,numero_de_conexiones_desde_el_ultimo_enter=0;
  	int sockList[64];//LISTA DE SOCKETS ALIMENTADOR AL PPW.
	int proxylist[64];//LISTA DE SOCKETS PPW AL PROXY.
  	int lastSock=0;
	int lastSockProxy=0;
	char buf1[2];//SE USA PARA DETECTAR EL ENTER POR LA ENTRADA ESTANDARD.



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/*OBTENGO ESTRUCTURA DEL PROXY*/

	struct  hostent *hm , *gethostbyname();
	hm = gethostbyname(argv[2]);

	if(argc!=4)
	{
		printf("Uso: ppw <puerto_local> <IP_proxy> <puerto_proxy>\n");
		exit(-1);
	}
	system("clear");

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/*LLENO LOS CAMPOS DE LA ESTRUCTURA PROXY*/

	bcopy ( hm->h_addr, &(proxy.sin_addr), hm->h_length);//LLENO LA IP.
	proxy.sin_family = hm->h_addrtype;//LLENO LA FAMILIA DE DIRECCIONES.
	proxy.sin_port = htons(atoi(argv[3]));//LENO EL PUERTO.
	
	printf("\n");
	printf("\t\t*****************************************\n");
	printf("\t\t Direccion ip servidor proxy: %s \n", inet_ntoa(proxy.sin_addr));
	printf("\t\t Puerto servidor proxy: %d \n", ntohs(proxy.sin_port));

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  /* LLENO LOS CAMPOS DE LA ESTRUCTURA SERVER CON LA INFORMACIN DEL SERVIDOR PPW*/

  	server.sin_family = AF_INET;
  	server.sin_addr.s_addr = htonl(INADDR_ANY);//htonl convierte desde el orden de los bytes del host al de la red(entero largo)
  	server.sin_port = htons(atoi(argv[1]));//htons convierte  desde el orden de bytes del host al de la red.(entero corto)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  /*CREO SOCKET S PARA COMUNICARME CON EL ALIMENTADOR*/

  	s = socket (AF_INET,SOCK_STREAM,0);//creo socket s
  	reusePort(s);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  /*CON BIND ASOCIO LA ESTRUCTURA SERVER CON EL SOCKET S QUE ME CONECTA CON EL ALIMENTADOR*/

  	if ( bind( s, (struct sockaddr *)&server, sizeof(server) ) )
	{
    		close(s);
    		perror("binding name to stream socket");
    		exit(-1);
  	}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	printf("\t\t Puerto servidor PPW: %d    \n", ntohs(server.sin_port));//ntohs convierte desde el orden de bytes de la red al del host.(entero corto)
	printf("\t\t*****************************************\n");
	printf("\t\t*  Para revisar bytes transferidos y    *\n");
	printf("\t\t*  conexiones realizadas,presione ENTER *\n");
	printf("\t\t*  Para terminar,presione Control+C     *\n");
	printf("\t\t*****************************************\n");

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*CON LISTEN SE ESPECIFCA EL DESEO DE ACPTAR CONEXIONES ENTRANTES Y UN LMITE DE LA COLA PARA DICHAS CONEXIONES*/

 	listen(s,5);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  	largofrom = sizeof(from);//tamao de la estructura from(donde se guardan los datos de los clientes).

  	FD_ZERO(&readfdsCopy);//limpia el conjunto de descriptores readfdsCopy.
  	FD_SET(s,&readfdsCopy);//aade el descriptor s al conjunto de descriptores readfdsCopy.
	FD_SET(0,&readfdsCopy);//aade el descriptor 0(entrada estandard) al conjunto de descriptores readfdsCopy.

  	for(;;)//LOOP INFINITO
	{

		memcpy(&readfds, &readfdsCopy, sizeof(fd_set));//copio area de memoria del conjunto de descriptores readfdsCopy al conjunto de descriptores readfds.
		n = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL);//marca los descriptores que necesitan atencin del conjunto readfds.

    		if (n > 0)
    		{
			if (FD_ISSET(s, &readfds)) //FD_ISSET mira si el descriptor es parte del conjunto de descriptores readfds QUE TIENE ACTIVIDAD.
      			{
				sockList[lastSock++] = accept(s, (struct sockaddr *)&from, &largofrom);
				numero_de_conexiones++;//aumento en 1 el numero de conexiones establecidas
				numero_de_conexiones_desde_el_ultimo_enter++;

				FD_SET(sockList[lastSock-1], &readfdsCopy);

				sl = socket (AF_INET,SOCK_STREAM,0);//CREACIN DE SOCKET SL PARA CONECTARME AL PROXY
				reusePort(sl);
				proxylist[lastSockProxy++]= sl;
				FD_SET(proxylist[lastSockProxy-1], &readfdsCopy);

				if (sl<0)
				{
					perror("opening stream socket");
  					exit(-1);
				}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

				/*ESTABLEZCO CONEXIN CON EL PROXY */

				if ( connect(sl, (struct sockaddr *)&proxy, sizeof(proxy)) < 0 )
				{
 					close(sl);
   					perror("connecting stream socket");
     					exit(0);
 				}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

			/*DETECTO ACTIVIDAD EN LA ENTRADA ESTANDAR*/

			if(FD_ISSET(0, &readfds))
			{
				int jc=0;
				if( (jc=read(0, buf1, sizeof(buf1))) >0)
				{
					printf("\t************************************************************");
					printf("\n\t Nmero de conexiones establecidas desde el incio: %d ",numero_de_conexiones);
					printf("\n\t Nmero de conexiones establecidas desde ENTER anterior: %d ",numero_de_conexiones_desde_el_ultimo_enter);
					printf("\n\t Nmero de bytes transferidos desde el inicio: %d ",bytes_desde_el_inicio);
					printf("\n\t Nmero de bytes transferidos desde ENTER anterior: %d \n",bytes_desde_el_ultimo_enter);
					printf("\t************************************************************");
					printf("\n\n");

					numero_de_conexiones_desde_el_ultimo_enter=0;
					bytes_desde_el_ultimo_enter=0;
				}
			}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

			for (i=0; i < lastSock; i++)
      			{
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		/*REVISO SI HAY ACTIVIDAD EN EL ARREGLO QUE CONTIENE LOS SOCKET CON QUE ME CONECTO DEL ALIMENTADOR AL PPW*/

				if (FD_ISSET(sockList[i], &readfds))
				{
					if (manejo(sockList[i],proxylist[i],0) < 0)
	    				{
	      					FD_CLR(sockList[i], &readfdsCopy);
						FD_CLR(proxylist[i], &readfdsCopy);
	      					sockList[i] = sockList[--lastSock];
						proxylist[i] = proxylist[--lastSockProxy];
	      					i--;

					}

				}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		/*REVISO SI HAY ACTIVIDAD EN EL ARREGLO QUE CONTIENE LOS SOCKET CON QUE ME CONECTO DEL PPW AL PROXY*/

				if (FD_ISSET(proxylist[i], &readfds))
				{
					if (manejo(proxylist[i],sockList[i],1) < 0)
	    				{
	      					FD_CLR(sockList[i], &readfdsCopy);
							FD_CLR(proxylist[i], &readfdsCopy);
	     					sockList[i] = sockList[--lastSock];
							proxylist[i] = proxylist[--lastSockProxy];
	     					i--;
						}
	    		}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			}
    	}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int manejo(int psd , int x , int h)//RECIBO DESDE PSD Y ENVIO A X.
{
  	char buf[512];
  	int rc=0;

  	for(;;)
	{
		if( (rc=read(psd, buf, sizeof(buf))) < 0)
    		{
      			perror("receiving stream  message");
    		}
		if(h==1)//DETECTO SI ESTOY RECIBIENDO DATOS DESDE EL PROXY O DESDE EL ALIMENTADOR
		{
			bytes_desde_el_inicio=bytes_desde_el_inicio+rc;
			bytes_desde_el_ultimo_enter=bytes_desde_el_ultimo_enter+rc;
		}

    	if (rc > 0)
		{
      		if (send(x, buf, rc, 0) <0 )
      		{
        		perror("sending stream message");
      		}
      		return(1);
    	}
    	else
    	{
      		close (psd);
			close(x);
      		return(-1);
    	}
  	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void reusePort(int s)//FUNCIN QUE ME PERMITE REUSAR EL PUERTO.
{
  int one=1;

  if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 )
  {
    printf("error in setsockopt,SO_REUSEPORT \n");
    exit(-1);
  }
}
